;*********************************************************************
; Mdulo: IERL
; Uso:    Trabajo de ISBC
; Autor:  Maria pilar Torres Bruna
;         borja Buera Rodriguez
; email:  444490@cepsz.unizar.es
;         448362@cepsz.unizar.es
;*********************************************************************
; Fecha Creacin: 30 de Octubre de 2001
; Versin: 0.0.1        Fecha Modificacin: 
; Estado:  Desarrollo  
;---------------------------------------------------------------------
; Uso: Base de conocimiento para la prueba de IERL.
; Comentarios:
; Historia:
;*********************************************************************

(defun base-form (name)
   (form :name name
         :is-a nil)
   (create-method name 'set-value   #'method-set-value)
   (create-method name 'set-aspect  #'method-set-aspect)
   (create-method name 'set-minimun #'method-set-minimun)
   (create-method name 'set-maximun #'method-set-maximun)
   (create-method name 'set-type    #'method-set-type)
   (create-method name 'set-have    #'method-set-have)
   (create-method name 'get-value   #'method-get-value)
   (create-method name 'get-aspect  #'method-get-aspect)
   (create-method name 'get-minimun #'method-get-minimun)
   (create-method name 'get-maximun #'method-get-maximun)
   (create-method name 'get-type    #'method-get-type)
   (create-method name 'get-have    #'method-get-have))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;; FUNCION DE CARGA DE JERARQUIA ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun bloques ()
   (let ()
      (base-form 'objeto)
      (form :name 'bloque             :is-a 'objeto)
      (form :name 'mesa               :is-a 'objeto)
      (form :name 'bloqueapoyo        :is-a 'bloque)
      (form :name 'cuadrado           :is-a 'bloqueapoyo)
      (form :name 'bloquenoapoyo      :is-a 'bloque)
      (form :name 'triangulo          :is-a 'bloquenoapoyo)
      (form :name 'circulo            :is-a 'bloquenoapoyo)
      (form :name 'rectangulo         :is-a 'bloqueapoyo)
     
      (set-value 'objeto 'ejemplar 'no)
      (set-value 'mesa 'tiene-encima nil)
      (set-value 'mesa 'tiene-debajo nil)
     
      ;; necesario para planificacion
      (set-value 'mesa 'dimension '(10 0))
      (set-value 'mesa 'posicion '(0 0))
     
      ;; dimensiones por defecto
      (set-value 'rectangulo 'dimension '(1 1))
      (set-value 'triangulo 'dimension '(2 2))
      (set-value 'circulo 'dimension '(2 2))   ;;guardamos el diametro
      (set-value 'cuadrado 'dimension '(1 1))
     
      ;; la dimension es:
      ;; (a b) a-> base (horizontal) b-> altura (vertical)
     
      (setf *lista-elementos* nil)
      ;; almacena todos los ejemplares que se han creado. sirve para redibujar la pantalla
     
      ;; fuera de estas dimensiones el programa puede no funcionar
      (setf *matriz-espacial* '((0 ()) (1 ()) (2 ()) (3 ()) (4 ()) (5 ())
                               (6 ()) (7 ()) (8 ()) (9 ())) )
    )
 )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;; MANEJO DE *MATRIZ-ESPACIAL* ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


 ;; pone como ocupado el rectangulo de lado horizontal ladox y lado vertical ladoy
 ;; a partir del punto marcado en posinicial (marca el vertice inferior izquierdo).
 ;; ladox y ladoy son ya dos numeros tal cual
 ;; posinicial es una lista tipo (x y)

 (defun actualizar-matriz-espacial (ladox ladoy posinicial)
   
   (if (eq ladoy 0) nil 
       (progn
 
         (setf nivel (second posinicial))
         (setf lista (assoc nivel *matriz-espacial*))
         (setf *matriz-espacial* (delete lista *matriz-espacial*))
         (setf nueva-lista (cons nivel (list 
              (do ((x (first posinicial)) 
                  (resultado (second lista)))
                  ((eq x (+ (first posinicial) ladox) ) resultado)
                  (setf resultado (cons x resultado))
                  (setf x (+ x 1))
              )
         )))
         
         (setf *matriz-espacial* (cons nueva-lista *matriz-espacial*))
         (actualizar-matriz-espacial ladox (- ladoy 1) (list (first posinicial) (+ (second posinicial) 1)))
         )
     )
  )


 ;; pone como libre el rectangulo de lado horizontal ladox y lado vertical ladoy
 ;; a partir del punto marcado en posinicial (marca el vertice inferior izquierdo).
 ;; ladox y ladoy son ya dos numeros tal cual
 ;; posinicial es una lista tipo (x y)


 (defun liberar-matriz-espacial (ladox ladoy posinicial)
   
    (if (eq ladoy 0) nil 
       (progn
 
          (setf nivel (second posinicial))
          (setf lista (assoc nivel *matriz-espacial*))
          (setf *matriz-espacial* (delete lista *matriz-espacial*))
          (setf nueva-lista (cons nivel (list 
              (do ((x (first posinicial)) 
                   (resultado (second lista)))
                   ((eq x (+ (first posinicial) ladox) ) resultado)
                   (setf resultado (delete x resultado))
                   (setf x (+ x 1))
              )
           )))
         
           (setf *matriz-espacial* (cons nueva-lista *matriz-espacial*))
           (liberar-matriz-espacial ladox (- ladoy 1) (list (first posinicial) (+ (second posinicial) 1)))
       )
    )
  )



 ;; hay-espacio devuelve true si hay espacio para meter el bloque de dimensiones
 ;; (ladox ladoy). Si no, devuelve false

 (defun hay-espacio (ladox ladoy posinicial)
   
    (setf nivel (second posinicial))
    (setf lista (assoc nivel *matriz-espacial*))

    (setf hay-e (do ((x (first posinicial))
       (resultado (second lista))
       (hay-esp 1))
       ((eq x (+ (first posinicial) ladox) ) hay-esp)
       (progn (if (member x resultado)
              (setf hay-esp 0))
              (setf x (+ x 1))
       )
    ))
   
    (if (eq hay-e 0) 0
        (if (eq ladoy 1) hay-e
          (hay-espacio ladox (- ladoy 1) (list (first posinicial) (+ (second posinicial) 1)))
    ))
 )



 ;; escribe una linea de la matriz de posicion y se llama a si mismo con la siguiente
 ;; linea, dibujando los bloques con "o" y los huecos con "x".

 (defun vuelca-fila (fila)
    (if (< fila 0) nil (progn
       (setf lista (second (assoc fila *matriz-espacial*)))
       (do ((x 0))
           ((eq x (first (get-value 'mesa 'dimension ))) nil)
           (if (member x lista) (msg "o ") (msg "x "))
              (setf x (+ x 1))
       )
                         
       (msg " % ")
       (vuelca-fila (- fila 1))                   
    ))
 )
       
 ;; vuelca por pantalla el contenido de *matriz-espacial*   

 (defun vuelca-matriz-espacial ()

    (vuelca-fila 8)  
 )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;; MOVIMIENTOS DE BLOQUES ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 ;; Coloca el bloque nombre1 encima del bloque nombre2, actualizando unicamente el slot
 ;; posicion de nombre1 y matriz-espacial

;; (defun colocar-encima (nombre1 nombre2)
;;    (setf x (first (get-value nombre2 'posicion)))
;;    (setf y (+ (second (get-value nombre2 'posicion)) (second (get-value nombre2 'dimension))))
;;    (set-value nombre1 'posicion (list x y))
;;    (actualizar-matriz-espacial (first (get-value nombre1 'dimension))
;;                              (second (get-value nombre1 'dimension)) 
;;                              (get-value nombre1 'posicion)  )
;;  )
  
 ;; calcula la posicion donde queremos colocar un bloque.
 ;; Devuelve una lista con el valor X, Y corresopndientes a la esquina superior izquierda
 ;; de nombre2
 ;; Se le llamara cuando necesitemos esa posicion por ejemplo para ver si ese espacio
 ;; esta vacio.

 (defun calcula-posicion (nombre1 nombre2)
    (setf x (first (get-value nombre2 'posicion)))
    (setf y (+ (second (get-value nombre2 'posicion)) (second (get-value nombre2 'dimension))))
    (list x y)
  )


;; El slot debajo del bloque queda vacio, y se borra bloque del slot encima de todos 
;; los bloques que tenia debajo bloque
;; Se le debe llamar cuando se quita un bloque.

 (defun actualiza-encima-debajo (bloque)
  
    ;; eliminar bloque del slot tiene-encima de todos los bloques que estan bajo bloque
    ;; en realidad solo puede ser uno, pues un bloque debe estar bajo otro unico bloque
    (setf lista (get-value bloque 'tiene-debajo))
   
    (dolist (elemento lista nil)
        (set-value elemento 'tiene-encima ( delete bloque (get-value elemento 'tiene-encima)))
    )
  
    (set-value bloque 'tiene-debajo nil)
 )
                         


 ;; Lo primero a hacer para ver si nos podemos mover a la derecha
 ;; es ver quien tenemos debajo.
 ;; a ver:
 ;; si hay espacio libre -> hay-espacio (ladox ladoy posinicial)
 ;; si continuaremos encima de quien estamos
 ;; Para ello:
 ;;    Si estamos encima de la mesa, ok  --> mirar si no nos caemos de la mesa
 ;;    Si no, ver encima de quien estoy
 ;;    coger las 


 ;; dice si bloque puede ser movido hacia la derecha una unidad

 (defun se-puede-a-la-derecha (bloque)
  
    (setf ladox 1)
    (setf ladoy (second (get-value bloque 'dimension)))
    (setf nueva-posx (+ (first (get-value bloque 'dimension)) (first (get-value bloque 'posicion))))
    (setf nueva-posy (second (get-value bloque 'posicion)))
   
    (if (eq (hay-espacio ladox ladoy (list nueva-posx nueva-posy)) 0) nil
       (if (equal (first (get-value bloque 'tiene-debajo)) 'mesa) 
          (if (<= (+ nueva-posx ladox) 10)
              t
              nil)
          (progn 
             (setf esta-debajo (first(get-value bloque 'tiene-debajo)))
             (setf debajox (first (get-value esta-debajo 'posicion)))
             (setf debajodim (first (get-value esta-debajo 'dimension)))
             (if (<= (+ 1 (first (get-value bloque 'posicion)) (first (get-value bloque 'dimension)))
                  (+ debajox debajodim)) t 
                  (progn (msg "Se sale del bloque de abajo. "))
             )
          )
    )
  )
)


 ;; dice si bloque puede ser movido a la izquierda una unidad

 (defun se-puede-a-la-izquierda (bloque)
  
    (setf ladox 1)
    (setf ladoy (second (get-value bloque 'dimension)))
    (setf nueva-posx (-  (first (get-value bloque 'posicion)) 1))
    (setf nueva-posy (second (get-value bloque 'posicion)))
   
    (if (eq (hay-espacio ladox ladoy (list nueva-posx nueva-posy)) 0) nil 
       (if (equal (first (get-value bloque 'tiene-debajo)) 'mesa) 
          (if (>= nueva-posx 0)
               t
               nil)
          (progn 
             (setf esta-debajo (first(get-value bloque 'tiene-debajo)))
             (setf debajox (first (get-value esta-debajo 'posicion)))
             (if (<= debajox nueva-posx) t 
                (progn (msg "Se sale del bloque de abajo. "))
             )
          )
    )
  )
)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;; FUNCIONES DE ACTUALIZACION Y AUXILIARES;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


 ;; crea las relaciones encima y debajo cuando un bloque se introduce sobre la mesa

 (defun aadir-a-mesa (bloque)
    (setf encima (get-value 'mesa 'tiene-encima))
    (set-value 'mesa 'tiene-encima (cons bloque encima))
 )


 ;; devuelve 'si si el bloque superior (bsuperior) es mas ancho que el bloque
 ;; inferior (binferior) ya que no se sostendria el primero encima del segundo

 (defun sobrepasa (bsuperior binferior)
   
     (setf dimxsuperior (first (get-value bsuperior 'dimension)))
     (setf dimxinferior (first (get-value binferior 'dimension)))
     (if (> dimxsuperior dimxinferior) 'si 'no)
  )


 ;; devuelve 'si si el bloque se quiere poner en una posicion negativa con 
 ;; respecto a la mesa o cuando se quiere poner en una posicion tal que
 ;; no estaria la totalidad del bloque apoyado sobre la mesa

 (defun se-sale-de-mesa (bloque posicion)
     (if (< posicion 0) 'si
       (if (> (+ posicion (first (get-value bloque 'dimension))) (first (get-value 'mesa 'dimension ))) 'si
         'no)
     )
  )

 ;; dev true si bloque es un cuadrado, un rectangulo, un circulo o un cuadrado

 (defun es-figura (bloque) 
   (setf salida 'no)
   (if (is-a? bloque 'circulo) (setf salida 'si)
     (if  (is-a? bloque 'triangulo) (setf salida 'si)
       (if  (is-a? bloque 'cuadrado) (setf salida 'si)
         (if (is-a? bloque 'rectangulo) (setf salida 'si)
                     t
         )
       )
     )
   )
   salida
 )
             
     

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;; FUNCIONES DE CONSULTA ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 ;; devuelve el numero de bloques totales que hay en la ventana

 (defun bloques-totales (bloque)
   
    (setf lista (get-value bloque 'tiene-encima))
    (setf numero 0)
   
    (dolist (elemento lista numero)
       (setf numero (+ 1 numero (bloques-totales elemento)))
    )
 )

 ;; devuelve el numero de bloques que tiene debajo un bloque 

 (defun bloques-totales-debajo (bloque)
   
    (setf lista (get-value bloque 'tiene-debajo))
    (setf numero 0)
  
    (dolist (elemento lista numero)
       (if (equal elemento 'mesa) nil
           (setf numero (+ 1 numero (bloques-totales-debajo elemento))))
    )
 )

 ;; calcula el area de un bloque cualquiera, pudiendose ser estos un cuadrado
 ;; un triangulo, un circulo o un rectangulo

 (setf *pi* 3.1416)

 (defun calcula-area (bloque)
  
    (setf dimx (first (get-value bloque 'dimension)))
    (setf dimy (second (get-value bloque 'dimension)))
    (setf radio (/ (first (get-value bloque 'dimension)) 2)) ;; por si acaso es circulo
   
    (if (is-a? bloque 'triangulo) (/(* dimx dimy) 2)
        (if (is-a? bloque 'circulo) (* radio radio *pi*)
           ;; else (es un cuadrado o rectangulo)
           (* dimx dimy)
        )
    )
  )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;; REDIBUJAR VENTANA ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 ;; aade un nuevo objeto a la lista de ejemplares del programa

 (defun agnadir-ejemplar (figura)
    (if (not (member figura *lista-elementos*))
        (setf *lista-elementos* (cons figura *lista-elementos*))
     t)
  )


 ;; pinta por pantalla un bloque concreto

 (defun redibujar (bloque)
  
    (if (is-a? bloque 'circulo)
      (pintar-circulo bloque)  
      (if (is-a? bloque 'triangulo)
        (pintar-triangulo bloque)
        (pintar-elemento bloque))
    )  
 )

 ;; redibuja todos los ejemplares que esten definidos de la pantalla que hayan sido 

 (defun redibujar-pantalla ()
   
    ;; redibujar mesa
    (crear-mesa)
   
    ;; redibujar los elementos colocados en la ventana
    (dolist (elemento *lista-elementos* t)
       (if (eq (get-value elemento 'colocado) 'si)
          (redibujar elemento)
      t)
    )
  )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;; PLANIFICACION BLOQUES ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; deja el bloque-movible sobre la mesa

 (defun deshacerse-de (bloque-movible)  
   (colocar-sobre bloque-movible 'mesa)
 )


;; quita bloques que esten apoyados en bloque-apoyo mientras no quede espacio
;; para poner encima el bloque-movible

 (defun hacer-espacio (bloque-movible bloque-apoyo)
   
   (setf lista-encima (get-value bloque-apoyo 'tiene-encima))
   
   (dolist (obstruccion lista-encima bloque-apoyo)
     (deshacerse-de obstruccion)
     (let ((espacio (encontrar-espacio bloque-movible bloque-apoyo)))
       (when espacio (return espacio)))  
     )
 )


;; busca en que posicion puede colocarse el bloque-movible sobre el bloque-apoyo
;; mira en todas las posiciones posibles a partir de la esquina izquierda arriba

 (defun encontrar-espacio (bloque-movible bloque-apoyo)
   
   (setf dim-x-movible (first (get-value bloque-movible 'dimension)))
   (setf dim-y-movible (second (get-value bloque-movible 'dimension)))
   (setf largo-apoyo (first (get-value bloque-apoyo 'dimension)))
  
   (setf inicio-x-busqueda (first (get-value bloque-apoyo 'posicion)))
   (setf inicio-y-busqueda (+ (second (get-value bloque-apoyo 'posicion))
                             (second (get-value bloque-apoyo 'dimension))))
                           
  
   ;; mirar si hay espacio en (inicio-x-busqueda,inicio-y-busqueda), 
   ;; (inicio-x-busqueda+1, inicio-y-busqueda), ... teniendo en cuenta la
   ;; largura del bloque movible
  
   (do ((sumarle 0 (+ sumarle 1)))
     ((> sumarle (- largo-apoyo  dim-x-movible )) nil)
    
     (setf lista-busqueda (list (+ inicio-x-busqueda sumarle) inicio-y-busqueda))
     (if (eq (hay-espacio dim-x-movible dim-y-movible lista-busqueda) 0) t
       (return lista-busqueda))  
   )
  
 )


;; devuelve una posicion relativa a la esquina arriba-izquierda del bloque-apoyo
;; en la que se puede colocar el bloque-movible, si es que puede colocarse.
;; O busca espacio o se lo hace

 (defun conseguir-espacio (bloque-movible bloque-apoyo) 
  
    (or (encontrar-espacio bloque-movible bloque-apoyo)
        (hacer-espacio bloque-movible bloque-apoyo)
    ) 
  )

;; nota: si encontrar-espacio dev true, entonces ya no ejecutara hacer-espacio


;; libera todos los bloques que tenga encima el objeto

 (defun liberar-objeto (objeto)
   
    (if (eq (get-value objeto 'tiene-encima) nil) t)
      (progn (setf lista-encima (get-value objeto 'tiene-encima))
         (dolist (obstruccion lista-encima t)
           (deshacerse-de obstruccion))
      )
     )
 )


;; lleva el bloque-movible encima del bloque-apoyo donde tenga sitio
;; debe haber hueco encima del bloque-apoyo para que quepa el bloque-movible

 (defun transferir (bloque-movible bloque-apoyo) 
    (msg "transferir " bloque-movible " sobre " bloque-apoyo " ") 
    (setf lugar-colocacion (conseguir-espacio bloque-movible bloque-apoyo))
  
    (if (not (listp lugar-colocacion))
        (msg " Error. No se puede encontrar espacio para transferir " bloque-movible " sobre " bloque-apoyo " ")
        (progn
           (if (eq (get-value bloque-movible 'colocado) 'si)
               (if (is-a? bloque-movible 'circulo)
                  (borrar-circulo bloque-movible)
                  (if (is-a? bloque-movible 'triangulo)
                    (borrar-triangulo bloque-movible)
                    (borrar-elemento bloque-movible)))
            t)

           ;; OJO! porque el bloque-movible podia estar ya colocado o no, por lo que en
           ;; ambas situaciones hay que hacer cosas distintas

           (if (eq (get-value bloque-movible 'colocado) 'si)
                (liberar-matriz-espacial (first (get-value bloque-movible 'dimension)) 
                              (second (get-value bloque-movible 'dimension)) 
                              (get-value bloque-movible 'posicion))
            t)
  

  
            (set-value bloque-movible 'posicion lugar-colocacion)
  
            ;; borrar del bloque que tiene debajo el valor bloque-movible de su 'tiene-encima
  
            (setf debajo (first (get-value bloque-movible 'tiene-debajo)))
    
            (if (eq (get-value bloque-movible 'colocado) 'si)
                (set-value debajo 'tiene-encima (delete bloque-movible (get-value debajo 'tiene-encima)))
             t)
  
             (set-value bloque-apoyo 'tiene-encima 
                (cons bloque-movible (get-value bloque-apoyo 'tiene-encima)))
    
             (set-value bloque-movible 'tiene-debajo (list bloque-apoyo))
             (set-value bloque-movible 'colocado 'si)

             (if (is-a? bloque-movible 'circulo)
                (pintar-circulo bloque-movible)  
                (if (is-a? bloque-movible 'triangulo)
                   (pintar-triangulo bloque-movible)
                     (pintar-elemento bloque-movible)  )  )
  
             (actualizar-matriz-espacial (first (get-value bloque-movible 'dimension)) 
                              (second (get-value bloque-movible 'dimension)) 
                              (get-value bloque-movible 'posicion)  )
  )

))

;; bloque-movible debe estar encima del bloque-apoyo al terminar la funcion
;; si no pudiera colocarse de primeras, se le busca sitio

(defun colocar-sobre (bloque-movible bloque-apoyo)
  
  (if (eq (get-value bloque-movible 'ejemplar) 'no)
      (msg " Error: " bloque-movible " no es un ejemplar ")
  
  (if (is-a? bloque-apoyo 'circulo)
      (msg " No se puede colocar ningun bloque sobre un circulo ")
    
  (if (is-a? bloque-apoyo 'triangulo)
      (msg " No se puede colocar ningun bloque sobre un triangulo ")
  
  (if (member bloque-movible (get-value bloque-apoyo 'tiene-encima))
      (msg " Objetivo ya cumplido ")
      
  
   (if (conseguir-espacio bloque-movible bloque-apoyo)
       (and (liberar-objeto bloque-movible) (transferir bloque-movible bloque-apoyo))
       (msg " Error. no hay espacio para colocar " bloque-movible " sobre " bloque-apoyo)
   )
))))
 )


   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; NOTAS APARTE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; SOLUCIONADOOOOOOOOOOOOSSS



;; mirar que si un bloque es mas ancho que el de abajo, que no se pueda colocar

;; + A es un ejemplar de cuadrado
;; Vale, A es un(a) ejemplar de CUADRADO
;; + el lado de A mide 3
;; Vale, El lado de A es 3
;; + B es un ejemplar de cuadrado
;; Vale, B es un(a) ejemplar de CUADRADO
;; + el lado de B mide 4
;; Vale, El lado de B es 4
;; + planificar A sobre mesa
;; conseguir espacioencontrar espacioliberar-objetotransferir A sobre MESAconseguir espacioencontrar espacio no se puede encontrar espacio 
;; + planificar B sobre A
;; conseguir espacioencontrar espacio
;; Error: `NIL' is not of the expected type `NUMBER'
;; [condition type: TYPE-ERROR]





;; mirar que estoy usando un hay-espacio que permite que mientras haya espacio,
;; que se sobrepase el bloque de apoyo

;; mirar si cabe el bloque, si son ejemplares y si no es triangulo o circulo


;; mirar si no es triangulo o circulo o no es ejemplar

;; al planificar sobre la mesa los elementos se van de izq a derecha

;; + planificar A sobre mesa
;; + el lado de B mide 2
;; Vale, El lado de B es 2
;; + planificar B sobre A
;; + el lado de C mide 1
;; + planificar C sobre A
;; + el lado de D mide 1
;; planificar D sobre A
;; Error: Attempt to take the cdr of A which is not listp.
;; [condition type: SIMPLE-ERROR]
;; hacer espacio D A lista-ecima es (C B)
;; transferir C sobre MESA
;; transferir B sobre MESA
;; transferir D sobre A 
;; hacer espacio D A lista-ecima es NIL

;; que no se me olvide usar pon-debajo quita-encima y demas leches


;; mirar este fallo. SEGURAMENTE es en pon-debajo que hace una cosa mu rara.
;; si es eso cambiarlo en la gramatica que tb se le llama desde alli

;; + coloca A sobre la mesa en la posicion 2
;; + planificar B sobre mesa
;; + quita C
;; Error C no esta colocado
;; + coloca C sobre B
;; + planificar B sobre A
;; + planificar C sobre A
;; + quita B
;; Error B tiene algun bloque encima


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;; FUNCIONES DESECHADAS ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; valor es un lista que contiene todos los bloques que estan encima del bloque
;; forma.  Se aadira forma al campo tiene-debajo de cada elemento de la lista
;; valor.
;; (defun pon-debajo (forma slot valor)
;;   (dolist (elemento valor nil)
;;     
;;     (if (member forma (get-value elemento 'tiene-debajo)) nil 
;;       (set-value elemento 'tiene-debajo (cons forma (get-value elemento 'tiene-debajo)))))   
;; )