; MODULO DE ENLACE CON DICCIONARIO WORDNET.
; Autor: Nuria Ripoll
; Fecha de creacin: 16-Nov-00
; Fecha de la ltima modificacin: 27-Feb-01

;; DICCIONARIO.LSP
;; HISTORIA
;; 31-Enero-2001. Nuria Ripoll.
;; Modifico las funcion posibles para meter los simbolos creados en el pkt dypar,
;; si no me da error de ejecucion porque los terminales no coinciden ya que estan
;; en distinto paquete.


(in-package "DYPAR")


;; Por defecto la categoria :noun
(setq *categoria* :noun)


;; Nuria Ripoll.20F.
;; "sinonimos2" devuelve la lista de simbolos correspondientes a las palabras sinonimas
;; del argumento que ha encontrado wordnet o bien, nil.
;; (CAT GUY HOMBRE)

;; Modifico para que se le llame desde smatch1.

(defun sinonimos2 (pal)
  (let ((lsinonimos nil)
	(lsin nil))
    (setq lsinonimos (append lsinonimos (mapcar #'car (user::get-synonyms pal *categoria*))))
    (and lsinonimos
         (dolist (sinonimo lsinonimos lsin)
	   (setq lsin (append lsin (list (intern (string-upcase sinonimo) 'dypar)))))
	 (remove-duplicates lsin))))










;; Esta funcion se llama desde "revisarfrase" en "orto.lsp" 
;; Devuelve la palabra q sustituye a la pasada como argumento si encuentra
;; alguna equivalente en el diccionario
(defun busca-diccionario (pal)
(format t "*categoria* = ~s ~%" *categoria*)
  (let ((npal nil))
  (setq npal (busca-palabra (posibles (sinonimos pal))))
  (cond
   (npal
    (format t "~%Se sustituye ~s por ~s" pal npal)
    npal)				;devolvemos la palabra sinonima
   
   (t					;no hay sinonimas en la gramatica
    (setq lpadres (padres pal))
    (cond
     (lpadres
      (setq npal (busca-palabra (posibles lpadres)))
      (cond
       (npal
	(format t "~%Se sustituye ~s por ~s" pal npal)
	npal)				;devolvemos el padre
       (t				;no hay padres en la gramatica
	(do ((padres lpadres (cdr padres))
	     (iter 1 (+ 1 iter)))
	    ((or (null padres) npal (> iter 2))
	     npal)
	  (format t "~%~s~%~%" iter)
	  (setq npal (busca-diccionario (car padres)))))))
     
     (t					;no hay sinonimas ni padres
      (format t "No se ha podido encontrar equivalencia")))))))


;; Si solo hay una palabra q pertenezca a la gramatica, la devuelve.
;; Si hay varias pregunta al usuario.
(defun busca-palabra (lposibles)
  (cond
   (lposibles
    (cond
     ((not (cdr lposibles))		;solo hay un posible cambio.
      (car lposibles))			;devolvemos la palabra
     
     (t					;hay varias posibilidades.
      (format t "~%Existen varias palabras equivalentes:~%")
      (let ((long (list-length lposibles)))
	(do ((posibles lposibles (cdr posibles))
	     (orden 1 (1+ orden)))
	    ((null posibles))
	  (format t "  ~s -> ~s~%" orden (car posibles)))
	(format t "  ~s -> No reemplazable por ninguno de los anteriores~%" (1+ long))
	
	(let ((num 0))
	  (do ((numero nil (read)))
	      ((and (numberp numero)
		    (> numero 0)
		    (<= numero (+ long 1)))
	       (setq num numero))
	    (format t "Indique la opcion correcta (1..~D): " (+ long 1)))
	  
	  (if (= num (+ 1 long))
	      nil
	    (nth (1- num) lposibles)))))))
   (t					;si nos pasan nil como argumento.
    nil)))


;; "posibles" devuelve, de la lista de palabras pasadas como argumento
;; aquellas que pertenecen a la gramatica cargada, es decir, que sean terminales.
;; (CAT GUY)
(defun posibles (lista)
  (let ((lposibles nil))
    (if lista
	(dolist (pal lista)
	  (and (get-terminal-hash (intern (string-upcase pal) 'dypar))
	       (setq lposibles (append lposibles (list (intern (string-upcase pal) 'dypar)))))))
    (remove-duplicates lposibles)))

;; "sinonimos" devuelve la lista de palabras sinonimas del argumento
;; que ha encontrado wordnet o bien, nil.
;; ("cat" "guy" "hombre")
(defun sinonimos (pal)
  (let ((lsinonimos nil))
    (setq lsinonimos (append lsinonimos (mapcar #'car (user::get-synonyms pal ':noun))))
    lsinonimos))

;; similar a "sinonimos", pero busca por la rama de los padres.
;; ("male" "adult_male")
(defun padres (pal)
  (let ((synsets (wn:index-entry-synsets
		  (wn:cached-index-lookup pal :noun)))
	(pointers)
	(padres))
    (dolist (s synsets)
      (dolist (p (wn:wordnet-pointers s))
	(when (eq (wn:wordnet-pointer-type p) :hypernym)
	  (setq padres (append padres (mapcar #'car (wn:synset-words (wn:wordnet-pointer-to-synset p))))))))
    padres))
